/* yasep/ASM/YASMed.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org

created 2009-01-23 by yg@yasep.org as tools/listed.js
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from St<E9>phane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des <E9>v<E9>nements avec seamonkey : souris qui d<E9>tecte pas le rel<E2>chement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai r<E9>uni les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
lun. févr. 13 04:59:42 CET 2012 : YASMed.js
lun. févr. 20 07:07:42 CET 2012 : export VHDL
sam. mars 24 14:01:02 CET 2012 : substitute
jeu. mai 10 04:44:20 CEST 2012 : moved from tool to ASM
mer. août 22 18:33:22 CEST 2012 : adding .org and ErrorLine
jeu. août 23 14:28:47 CEST 2012 : removing some global variables from win and using closures in win.asmctx functions
mar. août 28 01:20:11 CEST 2012 : some cleanup, checking instruction alignment, removing t.error and ErrorLine, making .org more functional, drag&drop of individual lines
jeu. sept. 27 13:57:30 CEST 2012 : warning sign in the title, win.errors and Types created
ven. oct.  5 03:27:46 CEST 2012 : adding features for the simulator (t.ot)
sam. oct. 20 10:42:19 CEST 2012 : removed the HTML
mer. nov. 21 01:50:39 CET 2012 : added the moving cursor, and rwx


Purpose : Create and maintain windows of the iterative assembly editor (derived from listed)

TODO : cleanup the trigger
TODO : better support for CPU profiles
 */

init_obj.push(YASMed={
  header: ";;;;;;;;;;;;;;; end auto header ;;;;;;;;;;;;;;;",
  serial:0,  // must be set by a cookie !!!

  OddEvenArray:["even", "odd"],

  Types:"Empty Code Org Align Name".split(" "),

  AdjustPClen:function(w){
    if (w.asmctx.name!="" && w.asmctx.core===false && config.core) {
      var t=w.memory.last, //LastAddress,
          i=0;
      while (t>0){ // iterative log2
        i++;
        t>>>=1;
      }
      config.core.PC_length=i;
    }
  },

  reassemble:function(ev, w) {
    w=parentWin(w||this);
    var n=impASM.importCode(YASMed.export_ASM(-1,w));
    // overlay the new window over the current one and close the old version
    ygwm.changeDimensions(w.w,w.h,n);
    ygwm.move(n,w.x, w.y);
    // reconnect :
    for (var i in w.Maps)
      Map.addEdit(n, w.Maps[i]);
    ygwm.erase_window(null,w)
  },

  export_ASM:function(ev, w) {
    // if ev==-1 then just return the original source code (see reassemble)
    if (w=parentWin(w||this)) {
      // ok now we have the window. let's generate a header for the new source code
      var h="; "+w.FuncName+generated(";","ASM/YASMed.js"),
          t= w.list_header_id.nextSibling, i,j="";
      if (w.subst.length>0) {
        h+="; Dump of the substitution table :\n";
        for (i in w.subst)
          h+=".subst "+w.subst[i].src+" "+w.subst[i].dst+"\n";
      }
      h+=I8N("nwol")+YASMed.header+"\n";

      // now scan the original window and concatenate all the source code.
      while(t) {
        j+=t.source_id.source+"\n";
        if (t.source_id.source==YASMed.header)
          j=""; // strip the header
        t=t.nextSibling;
      }
      // strip the trailing \n's
      t=j.length-1;
      while(j[t]=="\n")
        t--;
      j=j.slice(0,t+1);

      YASMed.AdjustPClen(w);
      h+=j;
      // commit
      if (ev===-1)
        return h;
      else
        savefile.save(w.FuncName+".yas",h);
    }
  },

  export_HEX:function(ev, w) {
    if (w=parentWin(w||this)) {
      if (w.errors)
          return Al8N("yalt1"); //"Can't export if the code contains error(s)"
      if (w.memory.first)
        return Al8N("yalt2"); // ".org is not supported"
      // ok now we have the window. create a header :
      var h=";;yhx0\n;; Dump of "+w.FuncName+generated(";;","ASM/YASMed.js"),
          t= w.list_header_id.nextSibling, i;
      // scan the source code and extract the binary output :
      while(t) {
        if(t.bytes)
          for(i in t.bytes_array)
            h+=int2hex( t.bytes_array[i],1,1,1)+" ";
        if(t.source_id.source!="")
          h+="; "+t.source_id.source+"\n";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(w);
      savefile.save(w.FuncName+".yhx",h);
    }
  },

  export_VHDL:function(ev, w) {
    if (w=parentWin(w||this)) {
      if (w.errors)
          return Al8N("yalt1"); //"Can't export if the code contains error(s)"
      if (w.memory.last & 1)
        return Al8N("even");
      if (w.memory.first)
        return AlrT(YASMed.alrt2); // ".org is not supported"
      if ((typeof w.asmctx.core == "object")
        &&(typeof w.asmctx.core.PC_length == "number")
        &&(w.memory.last > (1 << w.asmctx.core.PC_length) ))
        return Al8N("sztm");

      var size=w.memory.last >>1,
          t=w.list_header_id.nextSibling, i, j=0, k;
h="-- Dump of "+w.FuncName
+generated("--","ASM/YASMed.js")
+"Library work;\n"
+"    use work.yasep_definitions.all;\n"
+"    use work.yasep_utils.all;\n"
+"Library ieee;\n"
+"    use ieee.std_logic_1164.all;\n"
+"    use ieee.numeric_std.all;\n"
+"\n"
+"entity SynchRam16 is\n"
+" port(\n"
+"  clk, reset, en: in std_logic := '0';\n"
+"  NPC: in SLVAI;\n"
+"  RAM_out: out SLV16);\n"
+"end SynchRam16;\n"
+"\n"
+"architecture "+w.FuncName+" of SynchRam16 is\n"
+"  signal latched_addr : SLVAI := (SLVAI'range=>'0');\n"
+"  type RAM_array_type is array(0 to "+size+") of SLV16;\n"
+"  constant RAM_array : RAM_array_type := (\n";

      function emit_SLV16(s,k) { // This function handles the mask bits,
        var m='",';              // so it emits "-" when the bit is "don't care"
        for (i=16; i>0; i--) {
          if (k & 1)
            m=(s & 1)+m;
          else
            m='-'+m;
          s>>>=1;
          k>>>=1;
        }
        h+=' "'+ m;
      }

      // Scan the source code and emit the bits
      while(t) {
        if(t.bytes) {
          // is it an instruction ?
          if (t.ot!=="") {
            if (j  // some DB was not completely flushed
               ||(t.address & 1))
              return Alrt("Ierr2","",t.TrLineNr,"inaa");
            emit_SLV16(t.encoded_instruction, t.encoded_fields);
            if (t.bytes > 2)
              emit_SLV16(t.encoded_instruction >>> 16, t.encoded_fields >>> 16);
          }
          else {
            for(i in t.bytes_array) {
              var s=toBin(t.bytes_array[i],8);
              // accumulate 2 successive strings of 8 bits to make a 16-bits word
              // (note: j is initialised to 0 at the beginning of the function)
              if (!j++) // (j++==0)  OOoohh ugly...
                k=s;
              else {
                j=0;
                h+=' "'+s+k+'",';
              }
            }
          }
        }
        if(t.source_id.source!="")
          h+=" -- "+t.source_id.source+"\n";
        t=t.nextSibling;
      }

      YASMed.AdjustPClen(w);

h+=" \"1111111111111111\" );\n"  // Add "INV" because I wouldn't bother removing the last comma, plus the auto-prefetch gets the next word !
+"\n"
+"begin\n"
+"  process(clk, en)\n"
+"  begin\n"
+"    if rising_edge(clk) and en='0' then\n"
+"      latched_addr <= NPC;\n"
+"    end if;\n"
+"  end process;\n"
+"\n"
+"  process(latched_addr ,reset)\n"
+"    variable adr: integer;\n"
+"  begin\n"
+"    if reset/='1' then\n"
+"      RAM_out <= (RAM_out'range=>'0');\n"
+"    else\n"
+"      adr := safe_to_integer(latched_addr);\n"
+"      if adr < 0 or adr >= RAM_array'length then\n"
+"        report \" Accessing instruction beyond limit at \" & integer'image(adr);\n"
+"        RAM_out <= (RAM_out'range=>'1');\n"
+"      else\n"
+"        RAM_out <= RAM_array(adr);\n"
+"      end if;\n"
+"    end if;\n"
+"  end process;\n"
+"end "+w.FuncName+";\n";
      savefile.save(w.FuncName+".vhdl",h);
    }
  },

  // called by AssembleLine and duplicate_listing_row
  // and actually changes TR colors
  // Also catches unaligned instructions
  renumber_lines:function(w,t,n,ad) {
    // param #2 : id of the first TR to modify   => if null or absent, renumber everything
    // param #3 : its intended line number;
    // param #4 : byte address

    var u, orgNr=0, adi,
      err=w.errors,
      first=w.memory.first,
      size=ad - first;
      if (size<0) // because of .org
        size=0;

    if (!t // if only w is provided, renumber everything
      ||(t.previousSibling==w.list_header_id)) { // refresh anyway if it's the very first line
      t=w.list_header_id.nextSibling;
      n
       =ad
       =size
       =first
       =0;
      err=false;
      w.memory.mem=[]; // flush the memory
      w.memory.Id=[];
      w.erase_msg();
    }

    function mem(b){
      var m=w.memory;
      if (size & 1)
        b= (b << 8)
         | m.mem[size-1];
      else
        m.Id[size]=t;
      m.mem[(size++)& ~1]=b;
    }

    while (t != null) {
      t.address=ad;

      t.numero_id.innerHTML  // create/update the numbers
        = t.TrLineNr
        = n++;

      u=t.bgCol;
      if(t.Type==YASMed.Org) {
        if (orgNr++>0){
          u="error";
          w.shortmsg(I8N("R")+I8N("o1oa"));
        }
        else {
          if (ad>0){  // Catch .org at wrong line(s)
            u="error";
            w.shortmsg(I8N("R")+I8N("iod"));
          }
          else {
            u="";
            if (t.org == -1)
              w.memory.rwx &= ~8;
            else {
              w.memory.rwx |= 8;
              first
                =t.address // Missing from versions pre-20121117
                =ad
                =t.org;
            }
          }
        }
      }
      else
        // Check instruction alignment :
        if ((u==="")||(u=="unaligned")) { // don't touch other errors
          // recompute alignment in case it was shifted or reassembled
          u="unaligned";
          if (t.encoded_fields && (t.address & 1))  // unaligned opcode
            w.shortmsg(I8N("R")+I8N("ui"));
          else
            u=""; // no error
        }
 
      if (!(t.bgCol=u))
        u=YASMed.OddEvenArray[t.TrLineNr & 1]; // if no error, update the alternating background color
      else
        err=true;
      t.className=u;

      adi="";
      switch(t.Type) {

        case YASMed.Align:
          adi=ad;
          var m=t.algn-1,
              i=t.algn-(ad & m);
          ad+=i;
//          size+=i;
          if (i!=t.bytes) {
            t.bytes
               =t.size_id.innerHTML
               =i;
            t.bytes_array=[];
            while(i--) {
              mem(0);
              t.bytes_array.push(0);
            }
          }
          break;

        default:
          if (t.bytes>0){
            adi=ad;
            ad+=t.bytes;
//            size+=t.bytes;
            for(var i in t.bytes_array)
              mem(t.bytes_array[i]);
          }
      }// switch type

      t.address_id.ad.innerHTML=adi;

      t=t.nextSibling; // go to the next element
    }// end while

    // the end of the list is reached,
    w.lines=n;
    // update start address
    if (first!=w.memory.first)
      Map.changeStartAddress(w, first);
    Map.changeSize(w, size);
/*
    if(w.memory.last!=ad)
      alert("w.memory.last!=ad");
*/
    // Change the title, depending on the presence or absence of errors
    if((w.errors===NaN)||(w.errors!=err)){
      ygwm.changeWinTitle(w, (err?WARN:"")+w.FuncName, true);
      w.errors=err;
    }
  },

  Reassemble_line: function(t){
    var u=t.parentNode;
    YASMed.AssembleLine(parentWin(u),
      u, t.source, u.TrLineNr, u.address);
  },

  thContents:{
     "address":"&nbsp;&nbsp;$&nbsp;&nbsp;",
        "size":"sz",
       "value":"val",
      "source":"src",
     "message":"msg" },

  MakeRow: function(c,th) {
    var i,j,k,l, t=dcE("TR");
    t.onmouseover=YASMed.mouseover_row;
    for (i in c){
      j=dcE(th||"TD");
      k=c[i];
      t[k+'_id']=j;
      j.className=k;
      if(th && (l=YASMed.thContents[k]))
        j.innerHTML=I8N(l);

      switch(k) {
        case "plus" :
          j.title=I8N("aanl");
          j.onclick=
             th? YASMed.FirstLine : YASMed.duplicate_listing_row; // adapter plus tard
          break;
        case "numero" :
          j.title=I8N("mudt");
          if (!th)
            dragndrop.register(j, YASMed.dndRow, t);
          break;
        case "address" :
          j.appendChild(
            j.ad=dcE("SPAN")); // where the actual address will go
          break;
        case "source":
          if (!th)
            edit_text.register(j,
              { size:60, maxsize:200, func:YASMed.Reassemble_line });
      }
      t.appendChild(j);
    }
    return t;
  },

//  NewSym: function(win,s) {
//    return YASMed.MakeRow(["numero","symval","symname","symtype", "symcomm","symdef","symused"]);
//  },


// Called by NewLine, click->Reassemble_line, FirstLine, duplicate_listing_row
  AssembleLine: function(w, t, s, n, ad) {
// w : window
// t : tr / row of the table
// s : source code
// n : line number
// ad : address of the instruction's first byte
// Returns : nothing...

    t.bgCol
      =t.message_id.innerHTML
      =t.value_id.innerHTML
      =t.size_id.innerHTML
      =t.ot
      ="";
    t.source_id.source=s;
    t.source_id.innerHTML=s.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
    t.bytes_array=[];
    t.Type=YASMed.Code; // be optimistic, it can be changed further down...
    t.org
       =t.algn
       =null;
    t.bytes=0;

//// TODO À modifier !!!!!!!!!!!!
    for (var i in w.subst)
      s = s.replace(w.subst[i].rx, w.subst[i].dst);
//// Make a parser that skips pairs of '"'

    function add_message(col,msg){  // message display routine with closure
      t.message_id.innerHTML +='<span style="background-color:'+col+'">&nbsp;</span> '+msg+'<br>';
      if((col=="red")
       ||((col=="orange")&&(t.bgCol!="red")))
        t.bgCol=col;
    }
    w.asmctx.add_message=add_message;

    w.asmctx.emit_bin=
      function(data, size){
        var h="";
        while (size--) { // displays every byte
          t.bytes_array.push(data&255);
          h=int2hex(data&255,1,1,1)+h;
          data>>=8;
        }
        t.value_id.innerHTML+=h+" ";
      };

    if (s.length && s[0]==='.') {
      // preprocessor directive ? get the next word
      s=s.replace(/[;].*/,"");  // remove any trailing comment
      s=s.replace(/\s+/g," ");  // combine multiple spaces
      s=s.replace(/[ ]$/g,"");  // strip trailing garbage
      var i, s2=s.split(" ");

      function parse_parameter2() {
        if (s2.length!=2)
          return add_message("red",I8N("wdf"));

        s2=s2[1];
        if (s2.length > 30)
          return add_message("red",I8N("ns30"));

        // check for non alpha chars
        i=0;
        while (i < s2.length)
          if (alpha_chars[s2[i++]]!==1)
            return add_message("red",WARN+I8N("nac"));
        return s2;
      }

      switch(s2[0]) {
        case ".name": // Get the new name
          s=parse_parameter2();
          if (typeof s== "string"){
            t.Type=YASMed.Name;
            w.FuncName=s;
            w.errors=NaN; // force title change in renumber_lines
          }
          break;

        case ".org":
          // check if it's a valid number
          s=parse_parameter2();

          if (s=="auto"){
            t.Type=YASMed.Org;
            t.org = -1; // indicate that it's a relocatable block
          }
          else{
            i=str2int(s); // quiet : don't send an error message
            if ((i===null)||(i<0)) {
              add_message("red", I8N("wnf")+' '+s);
              break;
            }
            // redundancy and position checks are relegated to renumber_lines
            t.Type=YASMed.Org;
            t.org=i;
            // force rescan from the beginning of the listing
            t=null;
          }
          break; // trigger renumber_lines but renumber from the very start

        case ".align":
          // check if it's a valid number
          s=parse_parameter2();
          i=str2int(s); // quiet : don't send an error message
          if ((i===null)||(i<1)) {
            add_message("red", I8N("wnf")+' '+s);
            break;
          }
          if (i>512) {
            add_message("red", i+"??? "+I8N("wtf"));
            break;
          }
          if (i&(~i)) {
            add_message("red", i+I8N("np2"));
            break;
          }
          /* alignment is recomputed in renumber_lines */
          t.Type=YASMed.Align;
          t.algn=i;
          break;

        case ".profile": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",I8N("Bpn"));
            break;
          }
          if (s=="auto") {
            t.message_id.innerHTML+=I8N("oma");
            w.asmctx.core=false;
            break;
          }
          if (typeof profiles[s]!= "object") {
            add_message("red",I8N("pdne"));
            break;
          }
          t.Type=YASMed.Empty;

////////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          i = w.asmctx.YASEP_TYPE
            =(w.asmctx.core=profiles[s]).datapath;
          if((i==16)||(i==32))
            w.memory.rwx = ( w.memory.rwx & ~48) | i;
          break;

        case ".": // alias for "label"
          s=parse_parameter2();
          if (typeof s!= "string") {
            add_message("red",I8N("Bln"));
            break;
          }
          if ((typeof (i=w.tsbus[s2[1]])=="number")&& (w.subst[i].dst!=ad)){
            t.message_id.innerHTML+=I8N("svkod");
            break;
          }
          s2=[false,s,""+ad];
          // fold !

        case ".subst":
          if (s2.length<2) {
            add_message("red",I8N("Mws"));
            break;
          }
          var tr,dst="";
          if (s2.length<3)
            t.message_id.innerHTML+=I8N("whtw");
          else {
            i=2;
            while(true){
              dst+=s2[i++];
              if (!s2[i])
                break;
              dst+=" ";
            }
          }

          if (dst == s2[1]) { // skip substitution identity
            t.message_id.innerHTML+=I8N("idtt");
            break;
          }
          if (Y.keywords[s2[1].toUpperCase()]===true) { // keyword ?
            add_message("red",I8N("sbkw"));
          }

          (tr=dcE("DIV")).innerHTML="<b>"+s2[1].replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")
               +"</b> = \"<i>"+dst.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")+"\"</i>";
          var o={
            src:s2[1],
            dst:dst,
            rx:new RegExp(s2[1],"g"),
            tr:tr
          };
          w.subst_id.appendChild(tr);
          if (typeof (i
                      =w.tsbus[s2[1]])=="number"){
            rC(w.subst[i].tr);
            w.subst[i]=o;
          }
          else {
            w.tsbus[s2[1]]=w.subst.length;
            w.subst.push(o);
          }
          t.Type=YASMed.Empty;
          break;

        default: add_message("red",I8N("ukd"));
      }
    }
    else {
      Y.encode_instruction(s,w.asmctx);
      if (t.bytes
           =w.asmctx.encoded_size_bytes) {
        t.size_id.innerHTML=t.bytes;
        t.encoded_fields=w.asmctx.encoded_fields;
        t.encoded_instruction=w.asmctx.encoded_instruction;
        t.ot=w.asmctx.ot;

        // add the instruction to the used list
        if (w.asmctx.name!="" && w.asmctx.core===false)
          config.changeInstruction("true",w.asmctx.name);
      }
      else
        t.Type=YASMed.Empty;
    }

    YASMed.renumber_lines(w,t,n,ad);
  },

  listed_idNames:["plus","numero","address","size","value","source","message"],

  NewLine: function(w,s) {
    var t=YASMed.MakeRow(YASMed.listed_idNames);
    w.listed_id.appendChild(t);
    YASMed.AssembleLine(w,t,s,w.lines,w.memory.last);//LastAddress);
  },

  // Can this be merged with NewLine ?
  FirstLine: function(ev) {
    var w=parentWin(this),
        t=YASMed.MakeRow(YASMed.listed_idNames);
    w.listed_id.insertBefore(t,w.list_header_id.nextSibling);
    YASMed.AssembleLine(w,t,"",0,w.memory.first); //.start_address);
    return false;
  },

  duplicate_listing_row:function(ev) {
    // this is the id of the <td class="plus">
    var originalTR = this.parentNode,  // the TR
        p=originalTR.parentNode,       // The table
        w=parentWin(p);                // the window

    if (!ev.ctrlKey) { // Duplicate
      // new row:
      var newTR = YASMed.MakeRow(YASMed.listed_idNames);
      // include the new row in the table (which forces reflow and redraw)
      p.insertBefore(newTR,originalTR.nextSibling);
      YASMed.AssembleLine(w,newTR,
             ev.shiftKey?originalTR.source_id.source:"",
             originalTR.TrLineNr+1, originalTR.address+originalTR.bytes);
          // call NewLine instead ?
    }
    else  // Erase
      YASMed.remove_row(originalTR);
  },

  remove_row: function(tr){
    var w=parentWin(tr); // used after removal
    rC(tr); // Accroche-toi au DOM, j'enlève l'échelle !
    YASMed.renumber_lines(w); // un dernier coup pour la route
  },

///////////////////////////////////////////////////////////////////////////////////////////

// Drag&Drop of one TR into the same, or a different, listing

// generated by the following code :
//  moved_row_prev_index:null,
//  moved_row_newWin:null,
//  orig_win:null,
//  moved_row_prevSibling:null,

  mousedrop_row:function() {

// TODO : verify that the user drops inside a YASMed window, cancel the move otherwise

    if (YASMed.moved_row_newWin != YASMed.orig_win)
      YASMed.renumber_lines(YASMed.moved_row_newWin); // Rescan everything in case it was .org
    YASMed.renumber_lines(YASMed.orig_win);
  },

  // When the mouse goes over a TR :
  mouseover_row:function(/*ev*/) {
    if ((dragndrop.dragdropstate ==6) && (this != dragndrop.moved_item)) {
      var  newIndex=this,    // "this" is the TR
             parent=this.parentNode,
                win=parentWin(parent);

      // move a row within the same table ?
      if (YASMed.moved_row_newWin == win) {
        // evaluate where it's better to put the row...
        if ((this.TrLineNr  > YASMed.moved_row_prev_index)
        || ((this.TrLineNr == YASMed.moved_row_prev_index)
             &&(this.previousSibling==dragndrop.moved_item)))
          newIndex=this.nextSibling;
      }
      // move from another table/window :
      else  // focus and update moved_row_newWin
        ygwm.focus_window(null,
          YASMed.moved_row_newWin
          =win);

      dragndrop.moved_item=parent.insertBefore(dragndrop.moved_item,newIndex);
      YASMed.moved_row_prev_index = this.TrLineNr;
      return false;
    }
    return true;
  },

  // onmousedown : called by the dnd register function (start_move => this.dnd.ondrag(this.dndroot); )
  start_move_row:function(row) {
    YASMed.orig_win
     =YASMed.moved_row_newWin
     =parentWin(row);
    YASMed.moved_row_prev_index=row.TrLineNr;
    YASMed.moved_row_prevSibling=row.previousSibling;  // there is ALWAYS a previous sibling (the header or colgroups)
    row.className="selected";  // highlight / change the display style
  },

///////////////////////////////////////////////////////////////////////////////////////////

  unlinkArrow:function(s){
    var a=s.arrow;
    s.arrowDiv.appendChild(a); // back home !

//s.shortmsg("unlink "+s.winTitle);

//if(a.ed.simArrows)

    delete a.ed.simArrows[s.simCount]; //TypeError: can't convert undefined to object  (bug when the editor is closed when YASim has the cursor in it)
    a.ed=null; 
  },

  eraseCallback: function(w){
    var i,s;
    // scan all the YASims
    for (i in w.simArrows) {
      (s=w.simArrows[i]
         ).BPstop=true; // stop the sim that have a cursor in this YASMed
        // and reset the YASims   (also brings the cursor home)
      sim.resetState(s,5); // FAULT
    }

    Map.delAllEdit(w);
  },

  memCallback: function(w,a,rwx,sim,d){
    if (rwx & 1){ // execute ?
      // yes: move the cursor.
      var r=sim.arrow, c=sim.simCount, t=w.memory.Id[a];
      if (t){
        t.address_id.appendChild(r); // The DOM takes care of moving things around.
        if (r.ed!=w) {
          if (r.ed && r.ed.simArrows)  // unlink if already linked and window still exists
            delete r.ed.simArrows[c];
          // link the arrow to this YASMed
          w.simArrows[c]=sim;
          r.ed=w;
        }
      }
    }
  },

///////////////////////////////////////////////////////////////////////////////////////////

  // Create a new editor window
  start: function() {
    var plus, w, tt,tb,tr,
      c,d,e,f="function"+YASMed.serial,
      cont=dcE("DIV");
    w = ygwm.new_window("YASMed "+f, null, cont,
       600, 450, 120, 60, false, true, true, true, false, "doc_cygr");
    w.lines=0;
    w.FuncName=f;
    w.YasCount=YASMed.serial++;
    w.eraseCallback=YASMed.eraseCallback;
    w.Maps=[];
    w.MapDiv=[];

    d=dcE("DIV");
    d.appendChild(Map.NewMem(w, 1, 13, // rwx= R, X (no write), fixed (datapath size is changed later)
      YASMed.memCallback, 0, 0));
    w.memory.Id=[];

    button(d,"yara",YASMed.reassemble, 0,"1em");
    button(d,"yaea",YASMed.export_ASM, 0,"1em");
    button(d,"yahy",YASMed.export_HEX, 0,"1em");
    button(d,"yavh",YASMed.export_VHDL,0,"1em");

    d.appendChild(c=dcE("DIV"));

    cont.appendChild(d);

////////// Table:
      (tt=dcE("TABLE")).className="listed";
        (w.listed_id=dcE("TBODY")).appendChild(
          w.list_header_id
            =YASMed.MakeRow(YASMed.listed_idNames,"TH"));
      tt.appendChild(w.listed_id);
    cont.appendChild(tt);

    w.errors=false;
    w.asmctx=new Y.ASM_context(null, null, true, profiles["YASEP32"]);
         // 20120924 : added the core so the core configurator does not pop up unless we set .profile auto explicitly

    w.simArrows=[];
    w.subst=[];
    w.tsbus=[]; // reverse substitution
    cont.appendChild(e=dcE("P"));
      e.innerHTML="<u>"+I8N("sbst")+" :</u>";
    cont.appendChild(w.subst_id=dcE("DIV"));
        w.subst_id.className="subst";
    return w;
  },

  init_obj: function(){
    var r=". .NAME .SUBST .PROFILE .ORG .ALIGN".split(" "), i;
    for (i in r)
      Y.keywords[r[i]]=true;

    for (i in YASMed.Types)
       YASMed[YASMed.Types[i]]=i;

    YASMed.dndRow={
      trashBin:true,
      ondelete:YASMed.remove_row, //trash_row,
      ondrag:YASMed.start_move_row,
      ondrop:YASMed.mousedrop_row,
      state:6
    };

    menu.subMenuItem(menu.list["ASM"],i8n.ne, "ASM/YASMed");
  }
});
